# HG changeset patch
# User Pantxo Diribarne <pantxo.diribarne@gmail.com>
# Date 1507021881 -7200
#      Tue Oct 03 11:11:21 2017 +0200
# Node ID 45c209dd4935f9f5159c528667aa9f178cb4f217
# Parent  e250aeab3c85da520e14670f9559186a0d1c2a10
Provide default font files (bug #52150)

* ft-text-renderer.cc (ft_manager::do_get_font): use distributed FreeSans font
  as default ("*") or fallback font.
* run-octave.in: export OCTAVE_FONT_DIR
* etc/fonts: new directory containing default font files FreeSans.ttf, 
  FreeSansBold.ttf, FreeSansBoldOblique.ttf and FreeSansOblique.ttf. 

diff -r e250aeab3c85 -r 45c209dd4935 libinterp/corefcn/ft-text-renderer.cc
--- a/libinterp/corefcn/ft-text-renderer.cc	Tue Sep 26 15:18:31 2017 -0700
+++ b/libinterp/corefcn/ft-text-renderer.cc	Tue Oct 03 11:11:21 2017 +0200
@@ -55,6 +55,8 @@
 #include "singleton-cleanup.h"
 
 #include "error.h"
+#include "file-ops.h"
+#include "oct-env.h"
 #include "pr-output.h"
 #include "text-renderer.h"
 
@@ -205,8 +207,23 @@
 
       std::string file;
 
+      // Default font file
+      file = octave::sys::env::getenv ("OCTAVE_FONT_DIR");
+      if (! file.empty ())
+        {
+          file += octave::sys::file_ops::dir_sep_str () + "FreeSans";
+
+          if (weight == "bold")
+            file += "Bold";
+
+          if (angle == "italic")
+            file += "Oblique";
+
+          file += ".ttf";
+        }
+
 #if defined (HAVE_FONTCONFIG)
-      if (fontconfig_initialized)
+      if (name != "*" && fontconfig_initialized)
         {
           int fc_weight, fc_angle;
 
@@ -230,7 +247,7 @@
 
           FcPatternAddString (pat, FC_FAMILY,
                               (reinterpret_cast<const FcChar8 *>
-                               (name == "*" ? "sans" : name.c_str ())));
+                               (name.c_str ())));
 
           FcPatternAddInteger (pat, FC_WEIGHT, fc_weight);
           FcPatternAddInteger (pat, FC_SLANT, fc_angle);
@@ -254,7 +271,7 @@
                   file = reinterpret_cast<char *> (tmp);
                 }
               else
-                ::warning ("could not match any font: %s-%s-%s-%g",
+                ::warning ("could not match any font: %s-%s-%s-%g, using default font",
                            name.c_str (), weight.c_str (), angle.c_str (),
                            size);
 
@@ -267,15 +284,8 @@
 #endif
 
       if (file.empty ())
-        {
-#if defined (OCTAVE_USE_WINDOWS_API)
-          file = "C:/WINDOWS/Fonts/verdana.ttf";
-#else
-          // FIXME: find a "standard" font for UNIX platforms
-#endif
-        }
-
-      if (! file.empty ())
+        ::warning ("unable to find default font files");
+      else
         {
           if (FT_New_Face (library, file.c_str (), 0, &retval))
             ::warning ("ft_manager: unable to load font: %s", file.c_str ());
diff -r e250aeab3c85 -r 45c209dd4935 run-octave.in
--- a/run-octave.in	Tue Sep 26 15:18:31 2017 -0700
+++ b/run-octave.in	Tue Oct 03 11:11:21 2017 +0200
@@ -104,6 +104,7 @@
 OCTAVE_ARCHLIBDIR="$builddir/src"; export OCTAVE_ARCHLIBDIR
 OCTAVE_BINDIR="$builddir/src"; export OCTAVE_BINDIR
 OCTAVE_DEFAULT_QT_SETTINGS="$builddir/libgui/default-qt-settings"; export OCTAVE_DEFAULT_QT_SETTINGS
+OCTAVE_FONT_DIR="$top_srcdir/etc/fonts"; export OCTAVE_FONT_DIR
 OCTAVE_JAVA_DIR="$builddir/scripts/java"; export OCTAVE_JAVA_DIR
 OCTAVE_LOCALE_DIR="$builddir/libgui/languages"; export OCTAVE_LOCALE_DIR
 OCTAVE_SITE_INITFILE="$top_srcdir/scripts/startup/site-rcfile"; export OCTAVE_SITE_INITFILE
